(require [kodhy.macros [λ $ qw getl filt cbind]])

(import
  [numpy :as np]
  [pandas :as pd]
  [matplotlib.pyplot :as plt]
  [seaborn :as sns]
  [kodhy.util [T F rd]]
  pickle)

;(with [o (open "/media/luskin/assoc.pkl" "rb")]
;  (setv assoc-results (pickle.load o)))

(with [o (open "/media/luskin/pred_cv.pkl" "rb")]
  (setv pred-cv (pickle.load o)))
(setv pred-cv-orx (pd.DataFrame :columns (qw DV IVs twin MAE)
  (filt (!= (first it) "y_inpatient") pred-cv)))
(setv pred-cv-inpatient (pd.DataFrame :columns (qw DV prob_IVs amount_IVs MAE)
  (filt (= (first it) "y_inpatient") pred-cv)))

(with [o (open "/media/luskin/pred_coefci.pkl" "rb")]
  (setv pred-coefci (pickle.load o)))

(defn display-demog [k]
  (.map (get assoc-results k "demog") (λ
    (if (= it (int it))
      (str (int it))
      (.lstrip (format it ".3f") "0")))))

(defn display-bnc [k]
  (.applymap (get assoc-results k "subtotal_by_n_comorbs") (λ
    (format (int (round it)) ","))))

(defn display-assoc [k]
  (setv orig (get assoc-results k "association"))
  (setv d (pd.DataFrame :dtype str
    :index orig.index :columns orig.columns))
  (for [row orig.index col orig.columns]
    (setv v (getl orig row col))
    (setv (getl d row col) (cond
      [(or (pd.isnull v) (and
          (.endswith col "_cpreds")
          (in row (qw age_std age_std2))))
        ""]
      [(or (= v (int v))
          (in col (qw y_subtotal y_outpatient y_inpatient_nonzero y_drugs)))
        (format (int (round v)) ",")]
      [(.endswith col "_cpreds")
        (.lstrip (format v ",.3f") "0")]
      [True
        (format v ",.2f")])))
  (.rename :columns (λ (.lstrip it "y_"))
    (.applymap d (λ (.replace it "-" "−")))))
